#pragma once

namespace ss
{
    class MFIMMsgConext;
    class SS_Pong;
    class SS_MS_LoadGroup;
    class SS_MS_IMServerList;
}

class IMConn;
class IMConnMgr : public a8::Singleton<IMConnMgr>
{
 public:
    enum { HID = HID_IMConnMgr };

 private:
    IMConnMgr() {};
    friend class a8::Singleton<IMConnMgr>;

 public:

    void Init();
    void UnInit();

    void _SS_MS_IMServerList(f8::MsgHdr& hdr, const ss::SS_MS_IMServerList& msg);
    void _SS_Pong(f8::MsgHdr& hdr, const ss::SS_Pong& msg);

    IMConn* GetConnByKey(const std::string& key);
    IMConn* GetConnByInstanceId(long long instance_id);
    IMConn* RecreateIMConn(const std::string& host, int port);
    void TraverseIMConn(std::function<bool (IMConn*)> func);

 private:
    std::map<std::string, IMConn*> key_hash_;
    std::map<long long, IMConn*> id_hash_;
};
