#pragma once

enum SocketFrom_e
{
    SF_WSProxy,
    SF_IMServer,
    SF_IMConn,
    SF_MSConn,
};

enum GuildStatus_e
{
    kGuildCreatePending = 0,
    kGuildCreated = 1,
    kGuildDismissed = 2
};

enum GuildJob_e
{
    kGuildMember = 0,
    kGuildOwner = 1, //只能1个
    kGuildAdmin = 2, //只能1个
    kGuildElite = 3,
    kGuildJobMax
};

enum InnerMesssage_e
{
    IM_WSProxyDisconnect  = 100,
    IM_PlayerOffline,
    IM_ExecGM,
    IM_MasterSvrDisconnect,
    IM_IMServerSocketDisconnect,
    IM_IMConnConnect,
    IM_IMConnDisconnect,
    IM_MSConnConnect,
    IM_MSConnDisconnect
};

//网络处理对象
enum NetHandler_e
{
    HID_WSListener,
    HID_MasterSvrMgr,
    HID_IMListener,
    HID_PlayerMgr,
    HID_Player,
    HID_GroupMgr,
    HID_IMConnMgr,
    HID_SyncHelper,
    HID_GuildMgr,
    HID_Guild
};

enum ReadPointFlag
{
    RPF_FriendApply = 0,
    RPF_GuildApply = 1,
    RPF_Chat = 2
};

enum GuildMemberQuitReason
{
    kGuildKick = 0,
    kGuildQuit = 1,
    kGuildDismisss = 2,
    kGuildUpdate = 3,
};

enum GuildMemberUpdateReason
{
    kGuildUpdateReasonJoin = 0,
    kGuildUpdateReasonAgree = 1,
    kGuildUpdateReasonSetJob = 2,
    kGuildUpdateReasonInherit = 3,
    kGuildUpdateReasonUpdate = 4,
};

enum ChatChannel_e
{
    kCCBegin = 0,
    kCCWorld = 1,
    kCCPrivate = 2,
    kCCGuild = 3,
    kCCTeam = 4,
    kCCBigHorn = 5,
    kCCLoopMsg = 6,
    kCCEnd
};

const char* const PROJ_NAME_FMT = "friend_imserver";
const char* const PROJ_ROOT_FMT = "/data/logs/%s";

const char* const EVENT_FRIEND_AGREE = "friend.agree";
const char* const EVENT_FRIEND_DELETE = "friend.delete";

const char* const EVENT_GUILD_REFUSE = "guild.refuse";

const int MAX_INSTANCE_ID = 1023;

const int MAX_FRIEND_NUM = 30;
const int MAX_BLACKLIST_NUM = 10;
const int DAILY_JOIN_FRIEND_TIMES = 100;
const int DAILY_APPLY_FRIEND_TIMES = 100;

const int SYS_RESET_TIME = 2*60; //每日两点重置

const int SERVER_INTERNAL_ERROR = 100;

const int MAX_SYS_HTTP_NUM = 2;
const int MAX_USER_HTTP_NUM = 8;
const int MAX_ALL_HTTP_NUM = MAX_SYS_HTTP_NUM + MAX_USER_HTTP_NUM;
