#pragma once

namespace cs
{
    class MFBaseUserData;
}

class Player;
class Guild;
struct GuildMember;
class GameLog : public a8::Singleton<GameLog>
{
 private:
    GameLog(){};
    friend class a8::Singleton<GameLog>;
 public:

    void Init();
    void UnInit();

    void Login(Player* hum);
    void Logout(Player* hum);

    void FriendApply(Player* hum, const std::string& account_id);
    void FriendRefuse(Player* hum, long long db_idx, const std::string& account_id);
    void FriendAgree(Player* hum, long long db_idx, const std::string& account_id);
    void FriendDelete(Player* hum, const std::string& account_id);

    void GuildCreate(Player* hum, long long guild_id, const std::string& guild_name);
    void GuildApply(Guild* guild, const cs::MFBaseUserData& base_data);
    void GuildRefuse(Guild* guild, GuildMember* sender, long long db_idx, const std::string& account_id);
    void GuildAgree(Guild* guild, GuildMember* sender, long long db_idx, const std::string& account_id);
    void GuildKick(Guild* guild, GuildMember* sender, const std::string& account_id);
    void GuildQuit(Guild* guild, GuildMember* sender);
    void GuildSetJob(Guild* guild, GuildMember* sender, int old_job);
    void GuildAgreeInvite(Guild* guild, GuildMember* sender);

};
