#pragma once

namespace ss
{
    class MFIMMsgConext;
    class SS_IM_ForwardGuildCMMsg;
    class SS_IM_ForwardGuildSMMsg;
    class SS_IM_RefeshGuildMemberInfo;
    class SS_IM_PushGuildUserOnlineState;
    class SS_IM_GuildRecalcRedPoint;
    class SS_IM_GuildNewApply;
    class SS_IM_ApplyChangeResponse;
}

class Guild;
class AsyncGuildTask;
class GuildMgr : public a8::Singleton<GuildMgr>
{
 public:
    enum { HID = HID_GuildMgr };
 private:
    GuildMgr() {};
    friend class a8::Singleton<GuildMgr>;

 public:
    void Init();
    void UnInit();

    Guild* GetGuild(long long guild_id);

    template <typename T>
    void ForwardGuildSMMsg(int socket_handle, const ss::MFIMMsgConext& context, T& smmsg)
    {
        static int msgid = f8::Net_GetMessageId(smmsg);
        ForwardGuildSMMsg(socket_handle, context, msgid, smmsg);
    }
    void ForwardGuildSMMsg(int socket_handle,
                           const ss::MFIMMsgConext& context,
                           int msgid,
                           const ::google::protobuf::Message& smmsg);
    template <typename T>
    void SendMsg(int socket_handle, T& msg)
    {
        static int msgid = f8::Net_GetMessageId(msg);
        SendMsg(socket_handle, msgid, msg);
    }
    void SendMsg(int socket_handle,
                 int msgid,
                 const ::google::protobuf::Message& msg);
    void _SS_IM_ForwardGuildCMMsg(f8::MsgHdr& hdr, const ss::SS_IM_ForwardGuildCMMsg& msg);
    void _SS_IM_ForwardGuildSMMsg(f8::MsgHdr& hdr, const ss::SS_IM_ForwardGuildSMMsg& msg);
    void _SS_IM_RefeshGuildMemberInfo(f8::MsgHdr& hdr, const ss::SS_IM_RefeshGuildMemberInfo& msg);
    void _SS_IM_PushGuildUserOnlineState(f8::MsgHdr& hdr, const ss::SS_IM_PushGuildUserOnlineState& msg);
    void _SS_IM_GuildRecalcRedPoint(f8::MsgHdr& hdr, const ss::SS_IM_GuildRecalcRedPoint& msg);
    void _SS_IM_GuildNewApply(f8::MsgHdr& hdr, const ss::SS_IM_GuildNewApply& msg);

 private:
    void CreateAsyncTask(int socket_handle, long long guild_id, AsyncGuildTask* task);
    void LoadGuild(long long guild_id);
    bool IsValidGuildId(long long guild_id);

 private:
    std::map<long long, Guild*> id_hash_;
    std::set<long long> pending_guild_hash_;
    std::map<long long, std::list<AsyncGuildTask*>> task_hash_;
};
