#pragma once

class JsonDataMgr : public a8::Singleton<JsonDataMgr>
{
 private:
    JsonDataMgr() {};
    friend class a8::Singleton<JsonDataMgr>;

 public:
    void Init();
    void UnInit();

    std::shared_ptr<a8::XObject> GetConf();
    std::shared_ptr<a8::XObject> GetMasterServerClusterConf();
    std::shared_ptr<a8::XObject> GetRankServerClusterConf();
    std::shared_ptr<a8::XObject> GetMysqlClusterConf();
    bool GetRankServerConf(std::string& ip, int& port);
    int GetIMInstanceId(long long id);

 private:
    std::string work_path_ = "../config";
    a8::XObject mysql_cluster_json_;
    a8::XObject imserver_cluster_json_;
    a8::XObject masterserver_cluster_json_;
    a8::XObject rankserver_cluster_json_;
};
