#pragma once

#include "metadata.h"

#define TEXT(textid, def_text) MetaMgr::Instance()->GetText(textid, def_text)

class MetaDataLoader;
class MetaMgr : public a8::Singleton<MetaMgr>
{

 private:
    MetaMgr() {};
    friend class a8::Singleton<MetaMgr>;

 public:

    void Init();
    void UnInit();
    void Reload();

    MetaData::Guild* GetGuild(int guild_lv);
    std::string ReplaceDirtyWord(const std::string& text, char c);
    std::string GetText(const std::string& textid, const std::string& def_text="");

 private:
    MetaDataLoader* loader_ = nullptr;

    friend class MetaDataLoader;
};
