#include "precompile.h"

#include "typeconvert.h"
#include "cs_proto.pb.h"
#include "ss_proto.pb.h"

void TypeConvert::Convert(const cs::MFFriendApply& apply_pb, FriendApply& apply)
{
    apply.idx = apply_pb.idx();
    apply.applyid = apply_pb.applyid();
    apply.target_id = apply_pb.target_id();
    #if 0
    Convert(apply_pb.base_data(), apply.base_data);
    #endif
}

void TypeConvert::Convert(const FriendApply& apply, cs::MFFriendApply& apply_pb)
{
    apply_pb.set_idx(apply.idx);
    apply_pb.set_applyid(apply.applyid);
    apply_pb.set_target_id(apply.target_id);
    Convert(apply.base_data, *apply_pb.mutable_base_data());
}

void TypeConvert::Convert(const cs::MFGuildApply& apply_pb, GuildApply& apply)
{
    apply.idx = apply_pb.idx();
    apply.applyid = apply_pb.applyid();
    apply.guild_id = apply_pb.guild_id();
    #if 0
    Convert(apply_pb.base_data(), apply.base_data);
    #endif
}

void TypeConvert::Convert(const GuildApply& apply, cs::MFGuildApply& apply_pb)
{
    apply_pb.set_idx(apply.idx);
    apply_pb.set_applyid(apply.applyid);
    apply_pb.set_guild_id(apply.guild_id);
    Convert(apply.base_data, *apply_pb.mutable_base_data());
}

void TypeConvert::Convert(a8::XObject& xobj, cs::MFGuildBasic* guild_basic)
{
    guild_basic->set_guild_id(xobj.At("guild_id")->AsXValue());
    guild_basic->set_guild_name(xobj.At("guild_name")->AsXValue().GetString());
    guild_basic->set_guild_lv(xobj.At("guild_lv")->AsXValue());
    guild_basic->set_guild_exp(xobj.At("guild_exp")->AsXValue());
    guild_basic->set_guild_badge(xobj.At("guild_badge")->AsXValue());
    guild_basic->set_member_num(xobj.At("member_num")->AsXValue());
    guild_basic->set_guild_declaration(xobj.At("guild_declaration")->AsXValue().GetString());
    guild_basic->set_owner_id(xobj.At("owner_id")->AsXValue().GetString());
    guild_basic->set_owner_name(xobj.At("owner_name")->AsXValue().GetString());
    guild_basic->set_owner_avatar_url(xobj.At("owner_avatar_url")->AsXValue().GetString());
    guild_basic->set_owner_vip_lv(xobj.At("owner_vip_lv")->AsXValue());
    guild_basic->set_owner_head(xobj.At("owner_head")->AsXValue());
    guild_basic->set_join_unlimited(xobj.At("join_unlimited")->AsXValue());
    guild_basic->set_join_cond1(xobj.At("join_cond1")->AsXValue());
    guild_basic->set_join_cond2(xobj.At("join_cond2")->AsXValue());
    guild_basic->set__gameid(xobj.At("_gameid")->AsXValue());
    guild_basic->set__channel(xobj.At("_channel")->AsXValue());
    if (xobj.HasKey("applyed")) {
        guild_basic->set_applyed(xobj.At("applyed")->AsXValue());
    } else {
        guild_basic->set_applyed(0);
    }
}

void TypeConvert::Convert(a8::XObject& xobj, cs::MFPaging* paging)
{
    paging->set_curr_page(xobj.At("curr_page")->AsXValue());
    paging->set_page_size(xobj.At("page_size")->AsXValue());
    paging->set__total_page(xobj.At("_total_page")->AsXValue());
    paging->set__total_count(xobj.At("_total_count")->AsXValue());
}

void TypeConvert::Convert(const BaseUserData& base_data, ss::MFBaseUserDataDB& base_data_pb)
{
    base_data_pb.set_account_id(base_data.account_id);
    base_data_pb.set_nickname(base_data.nickname);
    base_data_pb.set_avatar_url(base_data.avatar_url);
    base_data_pb.set_sex(base_data.sex);
    base_data_pb.set_vip_lv(base_data.vip_lv);
    base_data_pb.set_head(base_data.head);
    base_data_pb.set_contribute(base_data.contribute);
    base_data_pb.set_last_login_time(base_data.last_login_time);
    base_data_pb.set_guild_id(base_data.guild_id);
    base_data_pb.set_guild_job(base_data.guild_job);
    base_data_pb.set_user_value1(base_data.user_value1);
    base_data_pb.set_user_value2(base_data.user_value2);
    base_data_pb.set_user_value3(base_data.user_value3);
    base_data_pb.set_base_data_version(base_data.base_data_version);
}

void TypeConvert::Convert(const ss::MFBaseUserDataDB& base_data_pb, BaseUserData& base_data)
{
    base_data.account_id = base_data_pb.account_id();
    base_data.nickname = base_data_pb.nickname();
    base_data.avatar_url = base_data_pb.avatar_url();
    base_data.sex = base_data_pb.sex();
    base_data.vip_lv = base_data_pb.vip_lv();
    base_data.head = base_data_pb.head();
    base_data.contribute = base_data_pb.contribute();
    base_data.last_login_time = base_data_pb.last_login_time();
    base_data.guild_id = base_data_pb.guild_id();
    base_data.guild_job = base_data_pb.guild_job();
    base_data.user_value1 = base_data_pb.user_value1();
    base_data.user_value2 = base_data_pb.user_value2();
    base_data.user_value3 = base_data_pb.user_value3();
    base_data.base_data_version = base_data_pb.base_data_version();
}

void TypeConvert::Convert(long long guild_id, int guild_job,
                          const GuildMember& member, ss::MFBaseUserDataDB& base_data_pb)
{
    base_data_pb.set_account_id(member.account_id);
    base_data_pb.set_nickname(member.nickname);
    base_data_pb.set_avatar_url(member.avatar_url);
    base_data_pb.set_sex(member.sex);
    base_data_pb.set_vip_lv(member.vip_lv);
    base_data_pb.set_head(member.head);
    base_data_pb.set_contribute(member.contribute);
    base_data_pb.set_last_login_time(member.last_login_time);
    base_data_pb.set_guild_id(guild_id);
    base_data_pb.set_guild_job(guild_job);
    base_data_pb.set_user_value1(member.user_value1);
    base_data_pb.set_user_value2(member.user_value2);
    base_data_pb.set_user_value3(member.user_value3);
    base_data_pb.set_base_data_version(member.data_version1);
}

void TypeConvert::Convert(long long guild_id, int guild_job,
                          const GuildMember& member, cs::MFBaseUserData& base_data_pb)
{
    base_data_pb.set_account_id(member.account_id);
    base_data_pb.set_nickname(member.nickname);
    base_data_pb.set_avatar_url(member.avatar_url);
    base_data_pb.set_sex(member.sex);
    base_data_pb.set_vip_lv(member.vip_lv);
    base_data_pb.set_head(member.head);
    base_data_pb.set_contribute(member.contribute);
    base_data_pb.set_last_login_time(member.last_login_time);
    base_data_pb.set_guild_id(guild_id);
    base_data_pb.set_guild_job(guild_job);
    base_data_pb.set_user_value1(member.user_value1);
    base_data_pb.set_user_value2(member.user_value2);
    base_data_pb.set_user_value3(member.user_value3);
    base_data_pb.set__online(member.online);
    base_data_pb.set_base_data_version(member.data_version1);
}

void TypeConvert::Convert(const ss::MFBaseUserDataDB& base_data_pb, GuildMember& member)
{
    member.account_id = base_data_pb.account_id();
    member.nickname = base_data_pb.nickname();
    member.avatar_url = base_data_pb.avatar_url();
    member.sex = base_data_pb.sex();
    member.vip_lv = base_data_pb.vip_lv();
    member.head = base_data_pb.head();
    member.contribute = base_data_pb.contribute();
    member.last_login_time = base_data_pb.last_login_time();
    member.user_value1 = base_data_pb.user_value1();
    member.user_value2 = base_data_pb.user_value2();
    member.user_value3 = base_data_pb.user_value3();
    member.data_version1 = base_data_pb.base_data_version();
}

void TypeConvert::Convert(const cs::MFBaseUserData& base_data_pb, GuildMember& member)
{
    member.account_id = base_data_pb.account_id();
    member.nickname = base_data_pb.nickname();
    member.avatar_url = base_data_pb.avatar_url();
    member.sex = base_data_pb.sex();
    member.vip_lv = base_data_pb.vip_lv();
    member.head = base_data_pb.head();
    member.contribute = base_data_pb.contribute();
    member.last_login_time = base_data_pb.last_login_time();
    member.user_value1 = base_data_pb.user_value1();
    member.user_value2 = base_data_pb.user_value2();
    member.user_value3 = base_data_pb.user_value3();
    member.data_version1 = base_data_pb.base_data_version();
}

void TypeConvert::Convert(const cs::MFBaseUserData& base_data_pb, BaseUserData& base_data)
{
    base_data.account_id = base_data_pb.account_id();
    base_data.nickname = base_data_pb.nickname();
    base_data.avatar_url = base_data_pb.avatar_url();
    base_data.sex = base_data_pb.sex();
    base_data.vip_lv = base_data_pb.vip_lv();
    base_data.head = base_data_pb.head();
    base_data.contribute = base_data_pb.contribute();
    base_data.online = base_data_pb._online();
    base_data.last_login_time = base_data_pb.last_login_time();
    base_data.guild_id = base_data_pb.guild_id();
    base_data.guild_job = base_data_pb.guild_job();
    base_data.user_value1 = base_data_pb.user_value1();
    base_data.user_value2 = base_data_pb.user_value2();
    base_data.user_value3 = base_data_pb.user_value3();
    base_data.base_data_version = base_data_pb.base_data_version();
}

void TypeConvert::Convert(const BaseUserData& base_data, cs::MFBaseUserData& base_data_pb)
{
    base_data_pb.set_account_id(base_data.account_id);
    base_data_pb.set_nickname(base_data.nickname);
    base_data_pb.set_avatar_url(base_data.avatar_url);
    base_data_pb.set_sex(base_data.sex);
    base_data_pb.set_vip_lv(base_data.vip_lv);
    base_data_pb.set_head(base_data.head);
    base_data_pb.set_contribute(base_data.contribute);
    base_data_pb.set__online(base_data.online);
    base_data_pb.set_last_login_time(base_data.last_login_time);
    base_data_pb.set_guild_id(base_data.guild_id);
    base_data_pb.set_guild_job(base_data.guild_job);
    base_data_pb.set_user_value1(base_data.user_value1);
    base_data_pb.set_user_value2(base_data.user_value2);
    base_data_pb.set_user_value3(base_data.user_value3);
    base_data_pb.set_base_data_version(base_data.base_data_version);
}

void TypeConvert::Convert(const cs::MFUserTempCustomData& temp_custom_data_pb,
                          UserTempCustomData& temp_custom_data)
{
    temp_custom_data.value1 = temp_custom_data_pb.value1();
    temp_custom_data.value2 = temp_custom_data_pb.value2();
    temp_custom_data.value3 = temp_custom_data_pb.value3();
}

void TypeConvert::Convert(const UserTempCustomData& temp_custom_data,
                          cs::MFUserTempCustomData& temp_custom_data_pb)
{
    temp_custom_data_pb.set_value1(temp_custom_data.value1);
    temp_custom_data_pb.set_value2(temp_custom_data.value2);
    temp_custom_data_pb.set_value3(temp_custom_data.value3);
}
