#pragma once

#include "framework/cpp/netmsghandler.h"

//game client listener
namespace a8
{
    class TcpListener;
}

namespace ss
{
    class SS_Ping;
}

class WSListener : public a8::Singleton<WSListener>
{
 public:
    enum { HID = HID_WSListener };

 private:
    WSListener() {};
    friend class a8::Singleton<WSListener>;

 public:
    void Init();
    void UnInit();

    template <typename T>
    void SendMsg(int sockhandle, T& msg)
    {
        static int msgid = f8::Net_GetMessageId(msg);
        f8::Net_SendMsg(tcp_listener_, sockhandle, 0, msgid, msg);
        #ifdef DEBUG
        f8::DumpMsgToLog(msg, "<<<<<<<WSL ");
        #endif
    }

    void SendText(int sockhandle, const std::string& text);

    void ForceCloseClient(int sockhandle);
    void MarkClient(int sockhandle, bool is_active);

    void _SS_Ping(f8::MsgHdr& hdr, const ss::SS_Ping& msg);

 private:
    a8::TcpListener *tcp_listener_ = nullptr;
};
