#include "precompile.h"

#include "typeconvert.h"
#include "cs_proto.pb.h"
#include "ss_proto.pb.h"

void TypeConvert::Convert(const cs::MFGuildBasic* guild_basic, a8::MutableXObject* xobj)
{
    xobj->SetVal("guild_id", guild_basic->guild_id());
    xobj->SetVal("guild_name", guild_basic->guild_name());
    xobj->SetVal("guild_lv", guild_basic->guild_lv());
    xobj->SetVal("guild_exp", guild_basic->guild_exp());
    xobj->SetVal("guild_badge", guild_basic->guild_badge());
    xobj->SetVal("member_num", guild_basic->member_num());
    xobj->SetVal("guild_declaration", guild_basic->guild_declaration());
    xobj->SetVal("owner_id", guild_basic->owner_id());
    xobj->SetVal("owner_name", guild_basic->owner_name());
    xobj->SetVal("owner_avatar_url", guild_basic->owner_avatar_url());
    xobj->SetVal("owner_vip_lv", guild_basic->owner_vip_lv());
    xobj->SetVal("owner_head", guild_basic->owner_head());
    xobj->SetVal("owner_sex", guild_basic->owner_sex());
    xobj->SetVal("join_unlimited", guild_basic->join_unlimited());
    xobj->SetVal("join_cond1", guild_basic->join_cond1());
    xobj->SetVal("join_cond2", guild_basic->join_cond2());
    xobj->SetVal("_gameid", guild_basic->_gameid());
    xobj->SetVal("_channel", guild_basic->_channel());
}

void TypeConvert::Convert(f8::JsonHttpRequest* request, cs::MFGuildBasic* guild_basic)
{
    std::string owner_id = request->request.At("owner_id")->AsXValue().GetString();
    int gameid = f8::ExtractGameIdFromAccountId(owner_id);
    int channel = f8::ExtractChannelIdFromAccountId(owner_id);
    guild_basic->set__gameid(gameid);
    guild_basic->set__channel(channel);
    guild_basic->set_guild_id(request->request.At("guild_id")->AsXValue());
    guild_basic->set_guild_name(request->request.At("guild_name")->AsXValue().GetString());
    guild_basic->set_guild_badge(request->request.At("guild_badge")->AsXValue());
    guild_basic->set_guild_lv(request->request.At("guild_lv")->AsXValue());
    guild_basic->set_guild_exp(request->request.At("guild_exp")->AsXValue());
    guild_basic->set_guild_declaration(request->request.At("guild_declaration")->AsXValue().GetString());
    guild_basic->set_owner_id(request->request.At("owner_id")->AsXValue().GetString());
    guild_basic->set_owner_name(request->request.At("owner_name")->AsXValue().GetString());
    guild_basic->set_owner_avatar_url(request->request.At("owner_avatar_url")->AsXValue().GetString());
    guild_basic->set_owner_vip_lv(request->request.At("owner_vip_lv")->AsXValue());
    guild_basic->set_owner_head(request->request.At("owner_head")->AsXValue());
    guild_basic->set_join_unlimited(request->request.At("join_unlimited")->AsXValue());
    guild_basic->set_join_cond1(request->request.At("join_cond1")->AsXValue());
    guild_basic->set_join_cond2(request->request.At("join_cond2")->AsXValue());
    guild_basic->set_owner_sex(request->request.At("owner_sex")->AsXValue());
}
